#!/bin/sh

#
# This is a dead-simple init.  (Any Docker container will almost
# certainly have a Bourne-compat shell.)  All it knows to do is look in
# a canonical dir for rcorder'd boot/shutdown scripts, and run them
# serially in order.  After this, on boot, it executes a startup command
# in compliance with the Docker entrypoint/command semantics; and on
# shutdown (SIGTERM from Docker), kills all immediate children of
# "init", waits a few seconds, then kills everything remaining.  In the
# meantime, we just do the usual init thing -- reap our adopted
# children.
#

function terminate() {
    local pids=`jobs -p`
    if [[ "$pids" != "" ]]; then
        kill $pids >/dev/null 2>/dev/null
    fi
}

trap cleanup EXIT
/path-to-your-app
}
